import java.io.*;
import java.util.*;
import javax.swing.text.*;
/**
 * La classe ListeTag represente une liste de Tag au sein <br>
 * du document
 */
public class ListeTag implements Serializable
{
private Vector _listeTag;
/**
 * renvoie la liste des tag sous forme de vecteur
 */
public Vector getListeTag(){return _listeTag;}

private void writeObject(java.io.ObjectOutputStream out)
     throws IOException
     {
     	out.writeObject(_listeTag);
     	
     }
private void readObject(java.io.ObjectInputStream in)
     throws IOException, ClassNotFoundException
     {
     	_listeTag = (Vector) in.readObject();
	
     	}
 
 
/**
 * constructeur de la classe
 */
 
public ListeTag(){_listeTag=new Vector(10,10);}
/**
 * Ajoute un tag a la liste
 */
public void add(Tag t) {
	System.err.println("ListeTag::add(Tag) :"+size());
	
	_listeTag.add(t);}
/**
 * renvoie le ieme tag de la liste
 */
public Tag get(int i) {return (Tag)_listeTag.get(i);}
/**
 * renvoie le tag , dont les bornes encadre au plus proche l'entier passer
 */
public Tag search(int caret)
{
Tag result=null;

for(int i=0;i<_listeTag.size();i++)
{
if (get(i).IsMe(caret)) 
{
if (result==null) result=get(i);
else
{
if (get(i).getTaille()<result.getTaille())
{
result=get(i);
}
}
}
}
return result;
}
/**
 * prend en compte le fait que dans le document , on a rajouter du text<br>
 * offset est l'endroit dans le document ou on a rajouter le texte<br>
 * taille est la taille du texte rajouter
 */
public void AddText(int offset,int taille,int nb_ligne)
{
System.err.println("Addtext :"+size());
for (int i=0;i<size();i++)
{
get(i).AddText(offset,taille,nb_ligne);
}
}
public boolean removeGroup(Tag tag)
{

if (tag==null) return false;
int offset=tag.getDebut();
int taille=tag.getFin()-tag.getDebut();
Vector tmp=new Vector(10,10);
for (int i=0;i<size();i++)
{
if (!get(i).IsDead(offset,taille)){
tmp.add(get(i));
}

}
_listeTag=tmp;
return true;
}
/**
 * enleve le tag "tag" de la liste <br>
 * renvoie vrai si le tag est dans la liste
 */
 
public boolean remove(Tag tag)
{
return _listeTag.remove(tag);
}
/**
 * prend en compte le fait que dans le document , on a enlever du text<br>
 * offset est l'endroit dans le document ou on a enlever le texte<br>
 * taille est la taille du texte enlever
 */
public void RemoveText(int offset,int taille,int nb_ligne)
{
Vector tmp=new Vector (10,10);
for (int i=0;i<size();i++)
{
if (!get(i).IsDead(offset,taille)){

get(i).RemoveText(offset,taille,nb_ligne);
tmp.add(get(i));
}

}
_listeTag=tmp;
}
/**
 * met a jour un document graphique avec les tag
 */
public void UpDateDocument(TextAreaPane pane)
{
pane.Clean();
for (int i=0;i<size();i++) 
{
if (get(i).IsDead()==false)
	pane.setAttributeSet(get(i).getBalise(),get(i).getDebut(),get(i).getFin());

pane.repaint();
}

}
/**
 * renvoie la taille de la liste
 */
public int size(){return _listeTag.size();}


/**
 * renvoie le tag qui debute ou commence par debutorend
 */
public Tag getTagAtDebutOrEnd(int debutorend)
{
for (int i=0;i<size();i++) if (get(i).getTagAtDebutOrEnd(debutorend)) return get(i);
return null;
} 

public int getRealPosition(int caret)
{
int result=caret;
for (int i=0;i<size();i++) 
{
Tag t=get(i);
if (t.getDebut()<=result) result=result+t.getDebutStringBalise().length();
if (t.getFin()<=result) result=result+t.getFinStringBalise().length();

}
return result;
}
}