

import javax.swing.text.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import javax.swing.*;
import org.xml.sax.SAXException;
import javax.swing.event.*;


/**
 * MainFrame represente la fenetre mere de l'application 
 *  @author Gros Pierre Emmanuel
 *         <a href="mailto:gros@limsi.fr">gros@limsi.fr</a>
 * @version 6.0
 */
public class MainFrame extends JFrame
{	
/**
 * la zone d'edition du texte
 */
protected  TextAreaPane _text1;
/** 
 * la fenetre d'edition des attribut
 */
protected CheckDialog _text2;
/**
 * la fenetre d'edition des styles de balises
 */
protected StyleEditBalise _text3;
/**
 * le repertoire courant ou se trouve les fichier
 */
protected File _directorie;

/**
 * la liste des tags (forme graphique)
 */
protected ListeTagIhm _text4;
/**
 * la liste des balises 
 */
protected ListeBalise _listeBalise;
//protected ContextMenu _contextmenu;
/**
 * la barre d'outil 
 */
protected JToolBar _toolBar;
/**
 * le menu
 */
protected JMenuBar _menuBar;
/**
 * la liste des tags
 */
protected ListeTag _listetag;
/** 
 * la ligne de statut
 */
protected JLabel _status;
/**
 * le nom du fichier dtd
 */
protected String _dtdfile;
/**
 * le validateur de XML
 */
protected XmlValidator _validator;
/**
 * le lecteur et le validateur de DTD
 */
protected DTDValidator _dtdvalidator;
/**
 * panneau de separation 
 */
protected JSplitPane _split1;
/**
 * panneau de separation 
 */
protected JSplitPane _split2;
/**
 * panneau de separation 
 */
protected JSplitPane _split3;
/**
 * panneau de separation 
 */
protected JSplitPane _split4;
protected StyleButton _style_bouton;
protected JMenu mBalise;
protected JMenuItem _style_Item;
/**
 * boite de dialogue d'edition de preference
 */
protected PreferenceDialog _pref;
public Vector GetDefaultColor(){return _text3.GetDefaultColor();}
public void initDefaultColorDialog(Vector v) {_text3.initDefaultColorDialog(v);}
public String getDTDFile(){return _dtdfile;}
private Action SaveFile()
{
ImageIcon iconOpen = new ImageIcon("export.gif");
Action toto = new AbstractAction("Export the document to Xml", iconOpen) 
{ 
	public void actionPerformed(ActionEvent e) 
	{
	
	SimpleFilter m_txtFilter=new SimpleFilter("xml","Text Document");
	final JFileChooser m_chooser = new JFileChooser(); 
    	m_chooser.setCurrentDirectory(_directorie);
  	m_chooser.addChoosableFileFilter(m_txtFilter);
        m_chooser.setFileFilter(m_txtFilter);
        MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
        Thread runner = new Thread() 
        {
	        public void run() {
        	 if (m_chooser.showSaveDialog(MainFrame.this) != JFileChooser.APPROVE_OPTION) return;
            	MainFrame.this.repaint();
            	MainFrame.this._directorie=m_chooser.getCurrentDirectory();

            	File fChoosen = new File(m_chooser.getSelectedFile().getAbsolutePath()+".xml");
		try {
                	 //_text1.load(fChoosen);
		 		FileWriter t=new FileWriter(fChoosen);
		 		PrintWriter pr=new PrintWriter(t,true);
		 		pr.print(GenerateXML.GenerateXML(_text1.getDocument(),_listetag,_dtdfile));
		 		pr.close();
		 		t.close();
			}
            	catch (Exception ex) {System.out.println(ex);}
            	MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
        }
};
runner.start();

	//System.out.println(GenerateXML.GenerateXML(_text1.getDocument(),_listetag));
	};

};
return (toto);


}


private Action Save()
{
ImageIcon iconOpen = new ImageIcon("saveb.gif");
Action toto = new AbstractAction("Save Balise ", iconOpen) 
{ 
	public void actionPerformed(ActionEvent e) 
	{try{
	
	PrintWriter h=new PrintWriter(new FileOutputStream("test.xml"));
	
	h.close();
	
	SimpleFilter m_txtFilter=new SimpleFilter("sav","XmlViewer SaveFile");
	final JFileChooser m_chooser = new JFileChooser(); 
    	m_chooser.setCurrentDirectory(_directorie);
  	m_chooser.addChoosableFileFilter(m_txtFilter);
        m_chooser.setFileFilter(m_txtFilter);
        MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
         if (m_chooser.showSaveDialog(MainFrame.this) != JFileChooser.APPROVE_OPTION) return;
            
            File fChoosen = new File(m_chooser.getSelectedFile().getAbsolutePath()+".sav");
	MainFrame.this._directorie=m_chooser.getCurrentDirectory();

	FileOutputStream ostream = new FileOutputStream(fChoosen);
	ObjectOutputStream p = new ObjectOutputStream(ostream);

  	   p.writeUTF(_dtdfile);
           p.writeObject(_listeBalise);
           p.close();
           
           
           MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
    
           }
catch (Exception s){System.err.println(s);}
};
};
return (toto);
}

private Action SaveDocument()
{
ImageIcon iconOpen = new ImageIcon("file_save.gif");
Action toto = new AbstractAction("Save annoted document...", iconOpen) 
{ 
	public void actionPerformed(ActionEvent e) 
	{
	try{
	SimpleFilter m_txtFilter=new SimpleFilter("xmldoc","XmlViewer SaveFile");
	final JFileChooser m_chooser = new JFileChooser(); 
    	m_chooser.setCurrentDirectory(_directorie);
  	m_chooser.addChoosableFileFilter(m_txtFilter);
        m_chooser.setFileFilter(m_txtFilter);
        MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
         if (m_chooser.showSaveDialog(MainFrame.this) != JFileChooser.APPROVE_OPTION) return;
            
            File fChoosen = new File(m_chooser.getSelectedFile().getAbsolutePath()+".xmldoc");
	MainFrame.this._directorie=m_chooser.getCurrentDirectory();

	FileOutputStream ostream = new FileOutputStream(fChoosen);
	ObjectOutputStream p = new ObjectOutputStream(ostream);

  	   p.writeUTF(_dtdfile);
           p.writeObject(_listeBalise);
           p.writeObject(_listetag);
           p.writeUTF(_text1.getDocument());
          
           p.close();
           
           MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
    
           }
catch (Exception s){System.err.println(s);}
};
};
return (toto);
}
private Action SaveDocument2()
{
ImageIcon iconOpen = new ImageIcon("file_save.gif");
Action toto = new AbstractAction("Save annoted document .", iconOpen) 
{ 
	public void actionPerformed(ActionEvent e) 
	{
	try{
	SimpleFilter m_txtFilter=new SimpleFilter("xml","XmlViewer SaveFile");
	final JFileChooser m_chooser = new JFileChooser(); 
    	m_chooser.setCurrentDirectory(_directorie);
  	m_chooser.addChoosableFileFilter(m_txtFilter);
        m_chooser.setFileFilter(m_txtFilter);
        MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
         if (m_chooser.showSaveDialog(MainFrame.this) != JFileChooser.APPROVE_OPTION) return;
            
            File fChoosen = new File(m_chooser.getSelectedFile().getAbsolutePath()+".xml");
	MainFrame.this._directorie=m_chooser.getCurrentDirectory();

	PrintWriter ostream = new PrintWriter(new FileOutputStream(fChoosen));
	
  	  /* p.writeUTF(_dtdfile);
           p.writeObject(_listeBalise);
           p.writeObject(_listetag);
           p.writeUTF(_text1.getDocument());*/
        
          SaveXml.WriteDocument(ostream,_listetag,_listeBalise,_text1.getDocument(),_dtdfile);
          ostream.flush();
          ostream.close();
           /*p.close();*/
           
           MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
    
           }
catch (Exception s){System.err.println(s);}
};
};
return (toto);
}
private Action Load()
{
ImageIcon iconOpen = new ImageIcon("openb.gif");
Action toto = new AbstractAction("Load balise ", iconOpen) 
{ 
	public void actionPerformed(ActionEvent e) 
	{
	
	try
	{SimpleFilter m_txtFilter=new SimpleFilter("sav","XmlViewer SaveFile");
	final JFileChooser m_chooser = new JFileChooser(); 
    	m_chooser.setCurrentDirectory(_directorie);
  	m_chooser.addChoosableFileFilter(m_txtFilter);
        m_chooser.setFileFilter(m_txtFilter);
        MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
         if (m_chooser.showOpenDialog(MainFrame.this) != JFileChooser.APPROVE_OPTION) return;
            
            File fChoosen = m_chooser.getSelectedFile();
		MainFrame.this._directorie=m_chooser.getCurrentDirectory();

 FileInputStream istream = new FileInputStream(fChoosen);
	ObjectInputStream p = new ObjectInputStream(istream);
         _dtdfile=p.readUTF();
         _listeBalise=new ListeBalise();
         _listeBalise=(ListeBalise)p.readObject();
         initStyleButton();
          _text3.UpDate(_listeBalise);
			
MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
    
}
catch (Exception s){System.err.println(s);}
};
};
return (toto);
}
private void initStyleButton()
{
if (_style_bouton!=null) mBalise.remove(_style_Item);
_style_bouton=new StyleButton(_listeBalise,_toolBar,this);
_style_Item=new JMenuItem(_style_bouton.Save());
mBalise.add(_style_Item);

}
private Action quit()
{
Action toto=new AbstractAction("quit")
{
public void actionPerformed(ActionEvent e) {System.exit(0);}
};
return toto;
}
private Action LoadDocument()
{
ImageIcon iconOpen = new ImageIcon("file_open.gif");
Action toto = new AbstractAction("Load annoted document", iconOpen) 
{ 
	public void actionPerformed(ActionEvent e) 
	{
	
	try
	{SimpleFilter m_txtFilter=new SimpleFilter("xmldoc","XmlViewer SaveFile");
	final JFileChooser m_chooser = new JFileChooser(); 
    	m_chooser.setCurrentDirectory(_directorie);
  	m_chooser.addChoosableFileFilter(m_txtFilter);
        m_chooser.setFileFilter(m_txtFilter);
        MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
         if (m_chooser.showOpenDialog(MainFrame.this) != JFileChooser.APPROVE_OPTION) return;
            
            File fChoosen = m_chooser.getSelectedFile();
		MainFrame.this._directorie=m_chooser.getCurrentDirectory();

 FileInputStream istream = new FileInputStream(fChoosen);
	ObjectInputStream p = new ObjectInputStream(istream);
         _dtdfile=p.readUTF();
         _listeBalise=new ListeBalise();
         _listeBalise=(ListeBalise)p.readObject();
         initStyleButton();
         _listetag=(ListeTag)p.readObject();
         _text1.setDocument(p.readUTF());
    
           
          _text3.UpDate(_listeBalise);
          _text1.repaintTag(_listetag);
          _text4.SetTag(_listetag,_text1.getDocument());
          	
			
MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
    
}
catch (Exception s){System.err.println(s);}
};
};
return (toto);
}
private Action LoadDocument2()
{
ImageIcon iconOpen = new ImageIcon("file_open.gif");
Action toto = new AbstractAction("Load annoted document", iconOpen) 
{ 
	public void actionPerformed(ActionEvent e) 
	{
	
	try
	{SimpleFilter m_txtFilter=new SimpleFilter("xml","XmlViewer SaveFile");
	final JFileChooser m_chooser = new JFileChooser(); 
    	m_chooser.setCurrentDirectory(_directorie);
  	m_chooser.addChoosableFileFilter(m_txtFilter);
        m_chooser.setFileFilter(m_txtFilter);
        MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
         if (m_chooser.showOpenDialog(MainFrame.this) != JFileChooser.APPROVE_OPTION) return;
            
            File fChoosen = m_chooser.getSelectedFile();
		MainFrame.this._directorie=m_chooser.getCurrentDirectory();
	FileReader f=new FileReader(fChoosen);
	DefaultHandlerLoadXml _reader=new DefaultHandlerLoadXml();
         _reader.lect(f);
         
         _dtdfile=_reader.getDtdFileName();
         System.err.println(_dtdfile);
         System.err.println(_reader.getDocument());
          System.err.println(_dtdfile);
         _listeBalise=new ListeBalise();
         _listeBalise=_reader.getListeBalise();
         _listetag=_reader.getListeTag();
         _text1.setDocument(_reader.getDocument());
    
           
          _text3.UpDate(_listeBalise);
          _text1.repaintTag(_listetag);
          _text4.SetTag(_listetag,_text1.getDocument());
          initStyleButton();
          	_text1.initLoad();
			
MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
    
}
catch (Exception s){System.err.println(s);}
};
};
return (toto);
}
public void repaint_mypanel()
{
_text1.repaintTag(_listetag);
_text3.UpDate(_listeBalise);
}
/**
 * met a jour les panneau avec un style de preferences
 * @param sa le style par preference
 */
public void setPreference(SimpleAttributeSet sa)
{
if (sa!=null) _listeBalise.setDefaultStyle(sa,true);

_text4.setBoth(!_pref.getBoth());
_text4.setFont1(_pref.getFont1());
_text4.setFont2(_pref.getFont2());
if (_text1!=null && _text1.getDocument()!=null ) _text4.SetTag(_listetag,_text1.getDocument());
_text1.repaintTag(_listetag);
_text3.UpDate(_listeBalise);
}

private Action Preference()
{
ImageIcon iconOpen = new ImageIcon("openb.gif");
Action toto = new AbstractAction("Preference", iconOpen) 
{ 
	public void actionPerformed(ActionEvent e) 
	{
	
	try
	{ _pref.setVisible(true);
		
}
catch (Exception s){System.err.println(s);}
};
};
return (toto);
}

/** 
 * mets a jour la ligne de status 
 * @param status le statut a afficher
 */
public void setStatus(String status)
{
_status.setText(status);
_status.repaint();
}
/**
 * renvoie la liste des tags
 * @result la liste des tags
 *
 */
public ListeTag getTag(){return _listetag;}
private Action LoadFile()
{
ImageIcon iconOpen = new ImageIcon("file_new.gif");
Action toto = new AbstractAction("Load a text document", iconOpen) 
{ 
	public void actionPerformed(ActionEvent e) {
	SimpleFilter m_txtFilter=new SimpleFilter("txt","Text Document");
	final JFileChooser m_chooser = new JFileChooser(); 
    	m_chooser.setCurrentDirectory(_directorie);
  	m_chooser.addChoosableFileFilter(m_txtFilter);
        m_chooser.setFileFilter(m_txtFilter);
        MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
        Thread runner = new Thread() 
        {
	        public void run() {
        	 if (m_chooser.showOpenDialog(MainFrame.this) != JFileChooser.APPROVE_OPTION) return;
            	MainFrame.this.repaint();
            	MainFrame.this._directorie=m_chooser.getCurrentDirectory();

            	File fChoosen = m_chooser.getSelectedFile();
		try {
		 	_listetag=new ListeTag();
                	 _text1.load(fChoosen);
		 	
			_text4.SetTag(_listetag,_text1.getDocument());
		 
			}
            	catch (Exception ex) {System.out.println(ex);}
            	MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
        }
};
runner.start();
}
};
return (toto);
}
private Action ValidatorStrict()
{
ImageIcon iconOpen = new ImageIcon("validS.gif");
Action toto = new AbstractAction("Open...", iconOpen) 
{ 
	public void actionPerformed(ActionEvent e) {
	_validator.Test(GenerateXML.GenerateXML(_text1.getDocument(),_listetag,_dtdfile),true);
	_validator.setVisible(true);
	}
};
return (toto);
}
private Action Validator()
{
ImageIcon iconOpen = new ImageIcon("valid.gif");
Action toto = new AbstractAction("Open...", iconOpen) 
{ 
	public void actionPerformed(ActionEvent e) {
	_validator.Test(GenerateXML.GenerateXML(_text1.getDocument(),_listetag,_dtdfile),false);
	_validator.setVisible(true);
	}
};
return (toto);
}

private Action LoadFileDTD()
{
ImageIcon iconOpen = new ImageIcon("dtd_open.gif");
Action toto = new AbstractAction("Load DTD File", iconOpen) 
{ 
	public void actionPerformed(ActionEvent e) {
	SimpleFilter m_txtFilter=new SimpleFilter("dtd","DTD File");
	final JFileChooser m_chooser = new JFileChooser(); 
    	m_chooser.setCurrentDirectory(_directorie);
  	m_chooser.addChoosableFileFilter(m_txtFilter);
        m_chooser.setFileFilter(m_txtFilter);
        MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
        Thread runner = new Thread() 
        {
	        public void run() {
        	 if (m_chooser.showOpenDialog(MainFrame.this) != JFileChooser.APPROVE_OPTION) return;
            	MainFrame.this.repaint();
            	MainFrame.this._directorie=m_chooser.getCurrentDirectory();

		try {
			File fChoosen = m_chooser.getSelectedFile();
			
			DTDReader DReader=new DTDReader();
			_dtdfile=new String(fChoosen.getPath());
			 System.out.println("_dtdFILE:"+fChoosen);
			 DReader.parseDTD(fChoosen.getAbsolutePath());
			 System.out.println(DReader.getData());
			 _listeBalise=DReader.getData();
			 _listeBalise.setDefaultStyle(_pref.getAttributesDefaultXML(),true);
			 _text3.UpDate(_listeBalise);
			_listetag=new ListeTag();
			_text4.SetTag(_listetag,_text1.getDocument());
			initStyleButton();
		      
			}
            	catch (Exception ex) {
                        _dtdvalidator.Test(new String("Erreur dans lecture DTD")+ex.toString());
                        _dtdvalidator.setVisible(true);
                }
            	MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
        }
};
runner.start();
}
};
return (toto);
}
/**
 * LectDTD permet de lire un fichier de dtd
 * @param filename la dtd
 */
public void LectDTD(String filename)
{
try {
			
			DTDReader DReader=new DTDReader();
			_dtdfile=new String(filename);
			 System.out.println(filename);
			 DReader.parseDTD(filename);
			 System.out.println(DReader.getData());
			 _listeBalise=DReader.getData();
			 _listeBalise.setDefaultStyle(_pref.getAttributesDefaultXML(),true);
			 _text3.UpDate(_listeBalise);
			_listetag=new ListeTag();
			_text4.SetTag(_listetag,_text1.getDocument());
			initStyleButton();
		      
			}
            	catch (Exception ex) {
                        _dtdvalidator.Test(new String("Erreur dans lecture DTD")+ex.toString());
                        _dtdvalidator.setVisible(true);
               }
}
/**
 * mets ajour la listes des tag pour le panneau d'edition
 */
public void UpDateTag()
{
_listetag.UpDateDocument(_text1);
}
/**
 * gere la selection d'un tag
 * @param t le tag selectionn
 */
public void select(Tag t)
{
System.out.println("select Tag t "+t.toString());
_text1.repaintTag(_listetag);
_text2.init(t.getBalise(),t);
_text2.getViewport().setVisible(true);
_text1.select(t.getDebut(),t.getFin(),t.getBalise().getAttribut());
_text4.select(t);
}
/**
 * enleve un tag de la liste et met a jour les panneau 
 * @param tag le tag a enlever
 * @result vrai si ca c'est bien passer
 */
public boolean remove(Tag tag)
{
boolean result=_listetag.remove(tag);
_text1.repaintTag(_listetag);
_text4.SetTag(_listetag,_text1.getDocument());
return result;
}
/**
 * enleve les tag de la liste entourant tag et met a jour les panneau 
 * @param tag le tag englobant
 * @result vrai si ca c'est bien passer
 */
public boolean removeGroup(Tag tag)
{
boolean result=_listetag.removeGroup(tag);
_text1.repaintTag(_listetag);
_text4.SetTag(_listetag,_text1.getDocument());
return result;
}

/**
 * mets jour graphiquement les differentes fenetres avec une position dans le texte
 * @param pos la position dans le texte
 *
 */
public void UpDateChild(int pos,boolean select)
{
Tag t=_listetag.search(pos);
if (t!=null) 
{
	_text2.init(t.getBalise(),t);
	_text2.getViewport().setVisible(true);
	_text1.repaintTag(_listetag);
	if (select) _text1.select(t.getDebut(),t.getFin(),t.getBalise().getAttribut());
        _text4.select(t);
}
	else 
	{
		_text2.getViewport().setVisible(false);
		_text1.repaintTag(_listetag);
	}
}
/**
 * mets a jour la liste des tags Ihm
 */
public void UpDateListe()
{
_text4.SetTag(_listetag,_text1.getDocument());
}
/**
 * defile les panneau pour voir la ligne ligne
 * @param ligne le numero de la ligne 
 */
public void viewLigne(int ligne)
{
System.err.println("ligne a scroller :"+ligne);
_text1.scroll(ligne);
}
/**
 * met a jour le style graphique d'une balise 
 * @param b la balise concerne
 * @param attrM le stylegraphique
 */
public void UpDateChild(Balise b,MutableAttributeSet attrM)
{
/* Est ce un tag */
/* oui  on init  avec le tag */


/* non on mais a jour la couleur et on enregistre le tag */
System.out.println("MainFrame::UpDateChild(Balise,MutableAttributSet");
/*if (_text1.setAttributeSet(attrM))
{*/

Tag tag=new Tag(b,_text1.get_debut(),_text1.get_fin(),_text1.getLigne(_text1.get_debut()));
//_text1.setDot(_text1.get_debut()) ;
_text1.GereFin(_text1.get_fin());
_listetag.add(tag);
XmlNode test=new XmlNode();
System.err.println("Balise b"+b);
System.err.println("LISTE TAG"+_listetag);
test.Init(_listetag);
System.err.println("Balise b"+b);
System.err.println("TEST"+test);
_listetag=test.toListeTag();
System.err.println("LISTE TAG"+_listetag);
_text1.setListeTag(_listetag);
_text3.Activate(b);
_text2.init(b,tag);
new Thread()
{
public void run()
{
_text4.SetTag(_listetag,_text1.getDocument());
_text1.repaintTag(_listetag);
}
}.start();
//}
}
/**
 * Cree la bar de menu
 * @result la barre de menu cree
 */
public JMenuBar create_JMenuBar()
	{
	JMenuBar menuBar = new JMenuBar();
	JMenu mFile = new JMenu("File");
    mFile.setMnemonic('f');
	
	
 JMenuItem item =  mFile.add(LoadFile());
  //item=mFile.add(LoadDocument());
   item=mFile.add(LoadDocument2());
 //item=mFile.add(SaveDocument());
item=mFile.add(SaveDocument2());

 item=mFile.add(LoadFileDTD());
   item=mFile.add(SaveFile());
   item=mFile.add(quit());
   mFile.add(item);
   
 JMenu mEdit = new JMenu("Edit");
    mEdit.setMnemonic('e');

    Action action = new AbstractAction("Copy", 
     new ImageIcon("edit_copy.gif")) 
    { 
      public void actionPerformed(ActionEvent e) {
        _text1.copy();
      }
    };
    item = mEdit.add(action);  
    item.setMnemonic('c');
    item.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_C, 
      KeyEvent.CTRL_MASK));

    action = new AbstractAction("Cut", 
     new ImageIcon("edit_cut.gif")) 
    { 
      public void actionPerformed(ActionEvent e) {
        _text1.cut();
      }
    };
    item = mEdit.add(action);  
    item.setMnemonic('t');
    item.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_X, 
      KeyEvent.CTRL_MASK));

    action = new AbstractAction("Paste", 
     new ImageIcon("edit_paste.gif")) 
    { 
      public void actionPerformed(ActionEvent e) {
        _text1.paste();
      }
    };
    item = mEdit.add(action);  
    item.setMnemonic('p');
    item.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_V, 
      KeyEvent.CTRL_MASK));
      
	_pref=new PreferenceDialog(MainFrame.this, GraphicsEnvironment.
      getLocalGraphicsEnvironment().getAvailableFontFamilyNames());
	 mBalise = new JMenu("Balise");
	 mBalise.add(Save());
 	mBalise.add(Load());
	mBalise.add(Preference());
	if (_style_Item!=null && _style_bouton!=null){
	_style_Item=new JMenuItem(_style_bouton.Save());
	mBalise.add(_style_Item);}
   	menuBar.add(mFile);
   	menuBar.add(mEdit);
   	menuBar.add(mBalise);
   	
	menuBar.setVisible(true);
	return menuBar;
	}
/**
 * Cree la bar des boutons
 * @result la barre cree
 */
public JToolBar createToolBar()
{
 JToolBar m_toolBar = new JToolBar();
    JButton bOpen = new SmallButton(LoadFile(), "Load texte document ");
    JButton bOpenXML = new SmallButton(LoadDocument2(), "Load annoted document ");
    JButton bSaveXML = new SmallButton(SaveDocument2(), "Save annoted document");
   
    JButton bOpenDTD = new SmallButton(LoadFileDTD(), "Load a DTD file");
   JButton validS=new SmallButton(ValidatorStrict(),"Valid document with DTD");
   JButton valid=new SmallButton(Validator(),"Valid quickly document");
    m_toolBar.add(bOpen);
     m_toolBar.add(bOpenXML);
      m_toolBar.add(bSaveXML);
      m_toolBar.addSeparator();
     m_toolBar.add(bOpenDTD);
    m_toolBar.addSeparator();
   m_toolBar.add(_status);
   	m_toolBar.add(validS);
	m_toolBar.add(valid);
   return (m_toolBar);
}
/**
 * met a jour la taille des panneaux
 */
protected void OnSize()
 {
 _split1.setDividerLocation(.5);
_split2.setDividerLocation(.75);
_split3.setDividerLocation(.75);
 }
/**
 * Constructeur de la fenetre
 */
 
public MainFrame()
{
super();
Dimension d=Toolkit.getDefaultToolkit().getScreenSize();
int height_screen=d.height;
int width_screen=d.width;
float pourcent=(float).1;
Point p=new Point((int)(width_screen*pourcent),(int)(height_screen*pourcent));
setLocation(p);
setSize((int)(width_screen*8*pourcent),(int)(height_screen*8*pourcent));
_directorie=new File(".");

_status=new JLabel();
_text1=new TextAreaPane(this);
_text2=new CheckDialog(this);
_text3=new StyleEditBalise(this);
_text4=new ListeTagIhm(this);
try
{ _split1=new JSplitPane(JSplitPane.VERTICAL_SPLIT,_text2,_text3);
  _split1.setDividerLocation(.5);

 _split2=new JSplitPane(JSplitPane.VERTICAL_SPLIT,_text1,_text4);
 _split2.setDividerLocation(.75);

 _split3=new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,_split2,_split1);
_split3.setDividerLocation(.75);

this.addWindowListener(new WindowAdapter()
		{
		public void windowClosing(WindowEvent e)
		{
			System.exit(0);
		}
		public void windowDeiconified(WindowEvent e) 
           
           	{
           	OnSize();
           	}
		public void windowOpened(WindowEvent e) 
		{
		OnSize();
		}
           
		}
);

_listetag=new ListeTag();
_validator=new XmlValidator(this);
_dtdvalidator=new DTDValidator(this);
_toolBar=createToolBar();

getContentPane().add(_split3, BorderLayout.CENTER);
getContentPane().add(_toolBar, BorderLayout.NORTH);
_menuBar=create_JMenuBar();
setJMenuBar(_menuBar);

setVisible(true);
}
catch (Exception e) {System.err.println(e);System.err.println("Erreur D'initialisation des splitting pane");System.exit(0);}
}

public void init()
{repaint();
OnSize();
repaint();
//_text3.GereDefault();	
try{
FileReader fr=new FileReader("xmljava.conf");
ReadPreference rf=new ReadPreference();
rf.lect(fr);
AttributeSet defaultattr=rf.Attribut();
if (defaultattr!=null) _pref.setAttributes(defaultattr);
_pref.setBoth(rf.getBoth());
if (rf.getDtdFileName()!=null) LectDTD(rf.getDtdFileName());
Vector mcolor=rf.getColor();
System.out.println(mcolor);
if (mcolor!=null) { initDefaultColorDialog(mcolor);_text3.UpDate(_listeBalise);}
fr.close();
}
catch (Exception e){System.out.println(e);};


}

 

public static void main(String [] args)
{
 
(new MainFrame()).init();

}
}
