import org.xml.sax.*;
import org.xml.sax.ext.DeclHandler;
import org.apache.xerces.parsers.SAXParser;
import org.xml.sax.helpers.DefaultHandler;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.swing.text.*;
import java.awt.*;
import java.awt.event.*;
/**
 * Permet delire les preference 
 *  @author Gros Pierre Emmanuel
 *         <a href="mailto:gros@limsi.fr">gros@limsi.fr</a>
 * @version 6.0
 */
public class ReadPreference  extends DefaultHandler implements DocumentBaliseName
{
private static final String
        DEFAULT_PARSER_NAME = "org.apache.xerces.parsers.SAXParser";


private String _dtdfilename;

private SimpleAttributeSet attribut_balise;
Vector mycolor;
boolean _both;
public SimpleAttributeSet Attribut() {return attribut_balise;}
/**
 * @result le nom du fichier
 */
public Vector getColor(){return mycolor;}
public String getDtdFileName(){return _dtdfilename;}
public boolean getBoth(){return _both;}
/**
 * hook appele lors du debut de lecture du document
 */
public void startDocument() 
{
}
/**
 * appele lors de la lecture du nom du fichier DTD
 * @param attr attribut de l'element XML
 */
public void lectDTD(Attributes attr)
{
_dtdfilename=new String(attr.getValue(attribut_name));
}
public void setBoth(Attributes att)
{
_both=(att.getValue(attribut_value)).equals("true");

}
public void createColor(Attributes att)
{
if (mycolor==null) mycolor=new Vector();
int red_front=Integer.parseInt(att.getValue(frontcolor_red));
int green_front=Integer.parseInt(att.getValue(frontcolor_green));
int blue_front=Integer.parseInt(att.getValue(frontcolor_blue));
Color front=new Color(red_front,green_front,blue_front);
mycolor.add(front);
}

SimpleAttributeSet createAttributStyleBalise(Attributes att)
{
SimpleAttributeSet result=new SimpleAttributeSet();
//StyleConstants.setFontSize(result,Integer.parseInt(att.getValue(fontsize)));
/*int red_back=Integer.parseInt(att.getValue(backcolor_red));
int green_back=Integer.parseInt(att.getValue(backcolor_green));
int blue_back=Integer.parseInt(att.getValue(backcolor_blue));
Color back=new Color(red_back,green_back,blue_back);
StyleConstants.setBackground(result, back) ;
int red_front=Integer.parseInt(att.getValue(frontcolor_red));
int green_front=Integer.parseInt(att.getValue(frontcolor_green));
int blue_front=Integer.parseInt(att.getValue(frontcolor_blue));
Color front=new Color(red_front,green_front,blue_front);
StyleConstants.setForeground(result,front) ;*/
String fontfamily=att.getValue(font);
StyleConstants.setFontFamily(result,fontfamily);
StyleConstants.setUnderline(result,att.getValue(underline).equals("true"));
StyleConstants.setBold(result,att.getValue(bold).equals("true"));
//StyleConstants.setStrikeThrough(result,att.getValue(strike).equals("true"));
StyleConstants.setItalic(result,att.getValue(italic).equals("true"));
return result;
}


public void startElement(java.lang.String uri, java.lang.String localName, java.lang.String qName, Attributes attributes) 
{
System.err.println("Element uri:"+uri+" localName:"+localName+" qName:"+qName);

if (localName.equals(style_def))
{
	attribut_balise=createAttributStyleBalise(attributes);
}else if (localName.equals(defaultdtdfile))
{
lectDTD(attributes);
}
else if (localName.equals(color))
{
createColor(attributes);
}
else if (localName.equals(both))
{
setBoth(attributes);
}
}
public void endElement(java.lang.String namespaceURI, java.lang.String localName, java.lang.String qName) 
{

}

public ReadPreference()
{

}
public void lect(FileReader f) throws Exception
{
  SAXParser  parser = (SAXParser)Class.forName(DEFAULT_PARSER_NAME).newInstance();
  
parser.setContentHandler (this);
     parser.parse(new InputSource(f));
    
} 
public static void main(String args[]) 
{
 try{ SAXParser  parser = (SAXParser)Class.forName(DEFAULT_PARSER_NAME).newInstance();
  DefaultHandler lo = new DefaultHandlerLoadXml();
parser.setContentHandler (lo);
     parser.parse(new InputSource(new FileReader(args[0])));
    }catch (Exception q) {System.err.println(q);}
     
}
           
}